\ bmw v0.0.8 31 Jamuary, 1999
\ based on

\ mf v0.0.13b  24 September 1997 +
\ Copyright 1997 Leo Wong.  All rights reserved.
\ hello@albany.net
\ http://www.albany.net/~hello/

\ Any residual copyright over modifications
\ Copyright 1997-1999 Bruce R. McFarling.
\ Right to incorporate any or all modifications
\ into MF under its copyright granted Leo Wong
\ All remaining rights reserved

\ Note that bmwslat.fs required by this file
\ is under its own copyright -- see that file
\ for its own boring copyright notice.

\ The marker goes in the same place as the 
\ high level actions WRITER and WRITER"
ONLY FORTH ACT DEFINITIONS MARKER *WRITER*

TOOLS DEFINITIONS VOCABULARY BMW

S" bmwtools.fs" REQUIRED

\ This defines some tools relied on by BMW. If some already
\ exist in your ANS Forth, comment them out in the source file.
\ see bmwtools for comments and stack interface
\  /CELL       /CHAR          NOP         -ROT        UMAX
\  UMIN        INCR           DECR        UNDER+      U/MOD
\  U/          BETWEEN        CLAMP       !PUT        @GET

S" bmwslat.fs" REQUIRED

\ A SLAT is a collection of rows the available width of the display
\ see bmwslat.fs for comments and stack interface
\  SLAT           SLAT-WIDTH     MAX-PLANKS     SOME-PLANKS
\  DEFAULT-PLANKS PLANKS         TOP-PLANK      END-PLANK
\  DIMENSIONS?    SLAT-XY        SLAT-Y         SLAT-VARIABLE
\  SLAT!          SLAT@          SLAT>          >SLAT
\  CLEAR-PLANK    CLEAR-PLANK>>  CLEAR-SLAT     CLEAR-PLANKS

ONLY FORTH
TOOLS BMWSLAT
TOOLS BMWTOOLS
TOOLS BMW DEFINITIONS

\ *** program parameters: adjust constants as needed **
\ Edit this file to change command key definitions, or
\ keep multiple versions, copying the one that you want
\ to use as BMWCONST.F

S" bmwconst.fs" INCLUDED

\ See the file bmwconst.fs for the following constants.
\ Also see bmwconst.fs for character constants beginning
\ with `^', e.g, ^COMMAND

\ character stands-ins for depicting white-space
\ .BL .CR ,OTHER

\ character keys stand-ins if control keys are unavailable
\ -Backspace-key(1) -Backspace-key(2) -Tab-key -Enter-key

\ ASCII control chars (use is an environmental dependency)
\ BEL BS HT FF 'CR DEL

: K* ( n1 -- n2 )  1024 * ;

\ filename delimiters
CHAR \ CONSTANT PATH-DELIMITER
CHAR : CONSTANT DRIVE-DELIMITER

1 K* CONSTANT CHARS/LINE

\ using ALLOCATE ?
TRUE CONSTANT Allocating
 128 CONSTANT Default-Allocate  \ in Ks

\ Beeps?

FALSE CONSTANT Beeps

\ indent to previous indent?
FALSE CONSTANT Smart-Indents

\ a cut or copy goes to memory if it fits,
\ otherwise to a file
2 K* CONSTANT Pocket-Size
CREATE POCKET  Pocket-Size CHARS ALLOT
 
\ *** screen display

 1 CONSTANT Ledge          \ room for spaces beyond linewidth

 3 VALUE Default-Tabwidth

: default-linewidth ( -- width )
   SLAT-WIDTH Ledge -
;

\ left margin holds line number
\ the start of a page is shown to the right of the line

\ *** Display Line Parameters

0 VALUE Tabwidth     \ Columns from one tabstop to the next
0 VALUE Linewidth    \ line width is tabwidth * tabs/line
0 VALUE Max-X        \ # of columns

\ Pseudo-values determined on the fly
\ * max-x less room for a prompt
: max-input ( -- u1 )          Max-X 16 - ;

\ * Tabstops per display line
: tabs/line ( -- tabs/line )   Linewidth Tabwidth / ;

\ * provide tabwidth if needed
: ?tabwidth ( -- tabwidth )
   Tabwidth ?DUP 0= IF
      Default-Tabwidth DUP TO Tabwidth
   THEN
;

\ * Set Linewidth, trimmed to fit display area
\ a '0' Linewidth uses the default
: set-linewidth ( linewidth -- )
   ?DUP 0= IF default-linewidth THEN   \ linewidth' <> 0
   SLAT-WIDTH Ledge - UMIN
   ?tabwidth OVER UMIN        \ ... tabwidth' <= linewidth
   DUP                     TO Tabwidth
   TUCK / *                            \ linewidth''
   DUP                     TO Linewidth
   Ledge +                 TO Max-X
;

default-linewidth set-linewidth

\ *** Display Row Parameters
  
SLAT-VARIABLE FULL-SLAT
SLAT-VARIABLE STATUS-SLAT
SLAT-VARIABLE REACT-SLAT
SLAT-VARIABLE INPUT-SLAT
SLAT-VARIABLE INFO-SLAT
SLAT-VARIABLE TEXT-SLAT
SLAT-VARIABLE TEXT0-SLAT
SLAT-VARIABLE TEXT1-SLAT
SLAT-VARIABLE TEXT2-SLAT
SLAT-VARIABLE DEBUG-SLAT

8 CONSTANT HELP-PLANKS
0 VALUE DISPLAY-TOP
MAX-PLANKS VALUE DISPLAY-LINES
TRUE VALUE DEBUG?

2 CONSTANT DEBUG-LINES  \ Seperate debug display
2 CONSTANT INFO-LINES   \ Height of INFO banner

: AT-STATUS ( -- ) STATUS-SLAT @>SLAT ;

: FULL-DISPLAY ( -- ) FULL-SLAT @>SLAT ;


\ ** Pseudo-values determined on the fly
\ * # planks to move for screen up or down
: SLAT-PAN ( -- slat-pan ) END-PLANK 3 4 */ 1+ ;

\ * The display top will normally be row 0, but might be lower
\ in another application; planks unchanged, space permitting
: SET-DISPLAY-TOP ( row parameter -- ) PLANKS >SLAT ;

\ * defines subslats of display
\ SLAT should already be set at the desired row origin
: SET-SUBSLATS ( planks-in-display -- )
   SLAT SWAP 2DUP >SLAT                      \ slat' height'
   FULL-SLAT COPY-SLAT
   INFO-LINES SPLIT-SLAT INFO-SLAT SLAT!
   DEBUG? IF
      PRY-LAST DEBUG-SLAT SLAT!
   THEN
   PRY-LAST INPUT-SLAT COPY-SLAT STATUS-SLAT SLAT!
   PRY-LAST REACT-SLAT SLAT!
   TEXT-SLAT COPY-SLAT TEXT0-SLAT COPY-SLAT
   HELP-PLANKS SPLIT-SLAT
   TEXT1-SLAT SLAT! TEXT2-SLAT SLAT! 
;
DISPLAY-TOP SET-DISPLAY-TOP
DISPLAY-LINES SET-SUBSLATS

\ displayable characters are implementation defined
126 CONSTANT LAST-DISPLAYABLE
\ this from Marcel Hendrix
\ TRUE PAD !  PAD C@  CONSTANT LAST-DISPLAYABLE

\ in-key
\ KEY is a Core word
: key-char (  -- c true )  KEY TRUE ;

' key-char VALUE (in-key
: in-key ( -- u flag ) (in-key EXECUTE ;

\ if your system supports it, and you want to, add
\ more keys (such as actual cursor keys) and use
\ EKEY instead of KEY :
\ : EVENT ( -- u flag )  EKEY EKEY>CHAR ;
\
\ ' EVENT TO (in-key

\ ** search / placemarks

\ PAD space
84 CONSTANT Pad-Space         \ region guaranteed by PAD

\ BMW uses PAD for search space:
\ if you want a bigger search space, this is where
\ you CREATE a dedicated search-pad buffer and
\ ALLOT Pad-Space chars to it.

Pad-Space CONSTANT GULP       \ #characters in search space
: search-pad ( -- )  PAD ;

\ ** constants for printing *
50 CONSTANT Lines/Page  \ printed page
\ 11 CONSTANT Pmargin   \ left margin for printing

\ ** debugging available in all states

: wait ( -- )  ."  (press a key)" in-key 2DROP ;

VARIABLE ~Count

\ **** This far in modifying case

\ * will display on whatever slat happens to be current
\ initialise it by passing it a null string.
\ since it clears the slat, it is normally used for transitions
\ between documents when .>DEBUG used in S-.S may crash
: .S-~ ( c-addr u -- )
   DEBUG? IF
      ?DUP IF
         ~Count DUP @ TUCK CLEAR-PLANK INCR
         . SPACE 2>R .S SPACE 2R> TYPE wait
      ELSE
         DROP 0 ~Count !
      THEN         
   ELSE DROP
   THEN
;

\ * gives a debugging to be used in a stepping debug display
\ it relies upon a TRUE value for DEBUG?
\ ... .~" <debug-label> " ... to show stack and label
\ ... .~" " ... to initialise the debug count.
: .~" ( -- ) POSTPONE S" POSTPONE .S-~ ; IMMEDIATE

\ ** display system preliminaries
' NOP VALUE (!TEXT-STATE
' NOP VALUE (@TEXT-STATE

\ * preserves text state. NB. Uses (!TEXT-STATE
: !TEXT-STATE ( -- ) (!TEXT-STATE EXECUTE ;

\ * restores text state. NB. Uses (!TEXT-STATE
: @TEXT-STATE ( -- ) (@TEXT-STATE EXECUTE ;

\ use TEXT as a temporary display
: .>TEXT ( -- )   !TEXT-STATE TEXT-SLAT   NEW-SLAT ;

\ return from a temporary display to main text display
\ NB. This does not refresh the display
: .>>TEXT ( -- ) TEXT-SLAT @>SLAT @TEXT-STATE ;

\ TEXT is the primary display, which is associated with
\ the text cursor.

\ Use pre-defined temporary displays
: .>STATUS ( -- ) !TEXT-STATE STATUS-SLAT NEW-SLAT ;
: .>REACT ( -- )  !TEXT-STATE REACT-SLAT  NEW-SLAT ;
: .>INPUT ( -- )  !TEXT-STATE INPUT-SLAT  NEW-SLAT ;
: .>INFO ( -- )   !TEXT-STATE INFO-SLAT   NEW-SLAT ;
: .>DEBUG ( -- )  !TEXT-STATE DEBUG-SLAT  NEW-SLAT ;

\ Still need to work out how to handle these before this
\ is ready to be committed to a stable slat.fs library:
\ SLAT-VARIABLE FULL-SLAT
\ SLAT-VARIABLE TEXT0-SLAT
\ SLAT-VARIABLE TEXT1-SLAT
\ SLAT-VARIABLE TEXT2-SLAT

\ ** warnings and debugging when display system is operative
\ If you want noisy warnings, hop over to bmwconst.fs and
\ define Beeps as TRUE.

' NOP VALUE (BEEP
: ?BEEP ( -- ) (BEEP EXECUTE ;

: BEEP ( -- ) BEL EMIT ;
: DEEP ( n)  DROP ?BEEP ;

: ?BEEPS ( -- ) Beeps IF ['] BEEP ELSE ['] NOP THEN TO (BEEP ;

' NOP VALUE (.REACTION
' NOP VALUE (.NORMAL
: ?DEBUG ( -- )
   DEBUG? IF ['] .S ELSE ['] NOP THEN TO (.NORMAL
;

: .REACTION ( -- ) (.REACTION EXECUTE (.NORMAL TO (.REACTION ;

\ * is used when the display has been set up to give debugging
\ information in process. It is the basis for .STEP and .STEP"
\ NB. *ONLY* use this if the memory used by !TEXT-STATE and
\ @TEXT-STATE is available. .S-~ is more general, although it
\ interferes with the current display  
: S-.S ( c-addr u -- )
   DEBUG? IF
      .>DEBUG 2>R .S ." : " 2R> TYPE wait .>>TEXT
   ELSE 2DROP
   THEN
;

\ * gives a labelled stack display with pause
\ ... .S" <debug advisory>"
: .S" ( -- ) POSTPONE S" POSTPONE S-.S ; IMMEDIATE

\ *** string words **
\ test the case of a character
\ * is this an upper case character?
: UPPER? ( c -- flag ) [CHAR] A [CHAR] Z BETWEEN ;

\ * is this a lower case character?
: LOWER? ( c -- flag ) [CHAR] a [CHAR] z BETWEEN ;

\ * makes a character lower case
: >lower ( C -- c ) DUP UPPER? BL AND XOR ;
 
\ * makes a character upper case
: >upper ( c -- C ) DUP LOWER? BL AND XOR ;

\ * switches the case of a character
: >other-case ( c|C -- C|c )
   DUP UPPER? IF >lower ELSE DUP LOWER? IF >upper THEN THEN
;
   
\ * make a string lower case
: s>lower ( a u -- )
   0 ?DO  DUP C@ >lower  OVER  C! CHAR+ LOOP
   DROP
;

: >EMPHASISED ( c -- [C] )
   DUP 'CR = IF
      DROP .CR
   ELSE
      DUP BL = IF DROP .BL ELSE >other-case THEN
   THEN
;

\ string less the number of trailing characters <> c
: -TRAILING<> ( a u1 c -- a u2 )
   >R BEGIN
   DUP WHILE
      1- 2DUP CHARS +
      C@ R@ = UNTIL
         1+
   THEN R> DROP
;

\ string after last character = c
: TRAILING<> ( a1 u1 c -- a2 u2 )
   OVER >R -TRAILING<> R>
   SWAP /STRING
;

\ leading characters = c
: LEADING= ( a u1 c -- a u2 )
   >R 2DUP BEGIN
   OVER C@ R@ = OVER AND WHILE
      1 /STRING
   REPEAT
   R> DROP NIP -
;

\ string less leading characters <> c
: -LEADING<> ( a1 u1 c -- a2 u2 )
   >R BEGIN
   OVER C@ R@ <> OVER AND WHILE
      1 /STRING
   REPEAT R> DROP
;

\ Given a substring of a string,
\ give the leading substring and original substring
: LEADING-SUBSTRING ( a1 u1 a2 u2 -- a2 u2 a1 u' )
   DUP >R 2SWAP R> -
;

\ Given a substring of a string,
\ give the trailing substring and original substring
: TRAILING-SUBSTRING ( a1 u1 a2 u2 -- a2 u2 a' u' )
   2SWAP + >R 2DUP + R> OVER -
;

\ string arithmetic
: C+! ( n a -- )  DUP C@ UNDER+ C! ;

: S+! ( a u s -- )
   2DUP 2>R
   COUNT CHARS +  SWAP CMOVE
   2R> C+!
;

\ move a counted string
: SMOVE ( s1 s2 -- )  OVER C@ 1+ CMOVE ;

\ move a cell counted string
: STR-MOVE ( s1 s2 -- ) OVER @ CHARS CELL+ MOVE ;

\ fill a counted string
: S>CS ( c-addr u s -- )
   2DUP C! CHAR+ SWAP CMOVE
;

\ add to a counted string
: CS+S ( c-addr u s -- )
   2DUP C@ + OVER C!       \ Extend string length
   COUNT + SWAP CMOVE      \ Fill at end of counted string
;

\ add to a cell-counted string -- there must be enough space
: CELL-COUNT ( addr -- c-addr u ) DUP CELL+ SWAP @ ;

: STR+ ( c-addr u s -- )
   OVER CHARS >R DUP CELL-COUNT CHARS + CELL+ >R
   +! R> R> MOVE              \ Fill at end of counted string
;

\ *** vectored execution **
VARIABLE way#           \ Mode meanings given by the following
: INSERTING? ( -- flag ) way# @ 0= ;
: OVERWRITING? ( -- flag ) way# @ 1 = ;
: MARKING? ( -- flag ) way# @ 2 = ;

: CALL ( a n -- ? )  CELLS + @ EXECUTE ;

: WAYS
   CREATE ( n -- )  0 ?DO  ' ,  LOOP
   DOES>  way# @  CALL
;

\ *** placemarker
\ -- start depth between max and min
2 DUP CONSTANT MIN-MARKER
7 DUP CONSTANT MAX-MARKER
OVER - 2/ +
  DUP CONSTANT CENTER-MARKER
      VALUE    PLACE-DEPTH

S" \ ********"

CREATE STAR-LINE DUP 1+ CHARS ALLOT
STAR-LINE S>CS

\ placemark string
\ clipped to actual string if PLACE-DEPTH too long
: PLACEMARK ( -- a u ) STAR-LINE COUNT PLACE-DEPTH MIN ;

\ Marker is inserted on a line of its own

\ *** file words **
\ at most two files are open at a time
\ the clipping file is kept open once opened
\ some error recovery could be introduced here
0 VALUE FILE-ID

\ create a file for writing
: CREATE-WRITE ( a u -- ) W/O CREATE-FILE THROW TO FILE-ID ;

: CREATE-READ ( a u -- ) R/O CREATE-FILE THROW TO FILE-ID ;

\ open or create a file for reading only
: OPEN-READ ( a u - )
   2DUP R/O OPEN-FILE IF
      DROP CREATE-READ
   ELSE
      TO FILE-ID 2DROP
   THEN
;

TRUE VALUE PROBLEM?
\ open a file for appending
: OPEN-APPEND ( a u -- )
   TRUE TO PROBLEM?
   2DUP R/W OPEN-FILE SWAP TO FILE-ID
   0= IF
      FILE-ID FILE-SIZE 0= IF
         FILE-ID REPOSITION-FILE TO PROBLEM?
      ELSE 2DROP
      THEN
   THEN
   PROBLEM? IF
      W/O CREATE-FILE THROW TO FILE-ID
   ELSE 2DROP
   THEN
;
\ close an opened file
: FCLOSE ( -- ) FILE-ID CLOSE-FILE THROW ;
\ attempt to close a file, ignore result
: ?FCLOSE ( -- ) FILE-ID CLOSE-FILE THROW ;

\ write u characters starting at a , then close the file
: >FILE ( a u -- )
   BEGIN
      ?DUP WHILE
         2DUP 'CR -LEADING<>  TUCK 2>R
         - FILE-ID WRITE-LINE THROW
         2R>  DUP IF  1 /STRING  THEN  \ get beyond 'cr
   REPEAT DROP
   FCLOSE
;
\ ** input buffer
CREATE IN-BUFFER CHARS/LINE 2 + CHARS ALLOT

\ read line into input buffer, add a cr
: FILE-LINE ( -- a u f )
   IN-BUFFER  DUP CHARS/LINE
   FILE-ID READ-LINE THROW
   >R 2DUP CHARS +  'CR SWAP C!  1+  R>
;
\ *** data structures **
\ ** chars and lines **
\ actual values determined later
0 VALUE TEXT   \ start of text area
0 VALUE CMAX   \ max # of characters
0 VALUE LINES  \ start of lines data
0 VALUE LMAX   \ max # of lines

\ ** cut & copy buffer; filename (with guard)
VARIABLE Doc-State
VARIABLE Old-Doc-State
6 CONSTANT DS-HEADER  \ not including link

: ALLOCATE-DOC-STATE ( filename-length -- address ior )
    6 + CHARS DS-HEADER 1+ CELLS + ALLOCATE THROW
;

: DS-NAME$ ( -- cs-addr ) Doc-State @ CELL+ DS-HEADER CELLS + ;
: NO-NAME$ ( -- c-addr u ) S" unnamed.txt" ; 

: cursor> ( -- cursor-addr )  Doc-State @ CELL+ ;

: old-place ( -- d-addr ) Doc-State @ 3 CELLS + ;

: reserve-space ( -- addr ) Doc-State @ 6 CELLS + ;

\ document state variables
VARIABLE char-now
VARIABLE line-now
VARIABLE top-line
VARIABLE last-line
VARIABLE .col
VARIABLE doc-size
VARIABLE top-old
VARIABLE last-old
VARIABLE line-old
VARIABLE deletes-length
VARIABLE col#

: INIT-STATE-VARIABLES ( -- )
   char-now OFF line-now OFF top-line OFF last-line OFF
   .col OFF doc-size OFF top-old OFF last-old OFF
   line-old OFF deletes-length OFF col# OFF
;

\ find screen row of line, top-line is plank#0
: >Y ( l# -- row#)  top-line @ - ;

: SAVE-PLACE ( -- )
   char-now @ line-now @ DUP >Y SWAP ROT
   old-place !PUT !PUT !
;

: PUSH-DOC-STATE ( c-addr u -- )
   Doc-State @ IF SAVE-PLACE THEN
   DUP ALLOCATE-DOC-STATE
   Doc-State @ OVER ! DUP Doc-State ! CELL+
   DS-HEADER 0 ?DO DUP OFF CELL+ LOOP
   S>CS
;

\ before the last character?
: -DOC-END ( -- f )  char-now @ doc-size @ U< ;

\ at the last character?
: DOC-END ( -- f ) char-now @ doc-size @ = ;

\ room to add u characters?
: ROOM? ( u -- f )  doc-size @ + deletes-length @ + CMAX 1+ U< ;

\ *** lines **
\ address of nth element of line array
: LINE ( l# - a )  CELLS LINES + ;

\ starting character # and length of a line
: LINESPEC ( l# - c# u )  LINE 2@ TUCK - ;

\ number of characters in a line
: LINELENGTH ( l# - u )  LINE 2@ - ;

\ zero line data between line#1 and line#2
: 0LINES ( l#1 l#2 -- )
   OVER - 1+ 0 MAX  >R  LINE  R>  CELLS ERASE 
;
\ zero all line information
: 0>LMAX ( -- )   0 LMAX  0LINES ;

\ add u to lines between current line and last line
: LINES+! ( u -- )
   line-now @ 1+ DUP  LINE SWAP
   last-line @  SWAP -  1+  0 MAX
   0 ?DO  2DUP +!  CELL+ LOOP  2DROP
;

\ move lines data starting with l# forward one cell
: LINES> ( l# -- )
   DUP LINE  DUP CELL+
   ROT last-line @ 1+  DUP last-line !
   SWAP - CELLS 0 MAX MOVE
;
\ move lines data starting with l#+1 back one cell
: <LINES ( l# -- )
   1+ DUP LINE  DUP CELL+  SWAP
   ROT last-line @ SWAP - CELLS 0 MAX MOVE
   last-line DECR
;
\ starting from a line, find the line a character is in
: C>L ( c# l#1 -- l#2 )
   OVER doc-size @ U< 0= IF
      2DROP last-line @
   ELSE
      OVER IF
         1- LINE BEGIN
            CELL+
         2DUP @ U< UNTIL
         NIP  LINES -  /CELL / 1-
      ELSE DROP
      THEN
   THEN
;
\ find bottom line of screen
: BOTTOMLINE ( -- u )  top-line @ END-PLANK + ;

\ *** allocate / allot memory **
\ allocate memory
0 VALUE ALLOCATED
FALSE VALUE SWITCH-STATE   \ true if leaving BMW, freeing memory 
FALSE VALUE PRESERVE-STATE \ preserve DOC-STATE 
FALSE VALUE RESTING        \ true if exiting with memory intact

\ GET-NUMBER from Woehr, Forth: the New Model
: GET-NUMBER ( -- ud f )
   0.
   PAD 84 BLANK
   PAD 84 ACCEPT
   PAD SWAP -TRAILING
   >NUMBER NIP 0=
;
\ get a number
: GET-INTEGER ( -- u ) GET-NUMBER DROP D>S ;

\ * REQUEST-INTEGER uses INPUT-SLAT, requires prompt string
\ returns integer on stack
: REQUEST-INTEGER ( c-addr u1 -- u2 )
   !TEXT-STATE INPUT-SLAT NEW-SLAT
   TYPE GET-INTEGER .>>TEXT
;

\ * REQUEST-STRING uses INPUT-SLAT, requires prompt string
\ returns counted string in PAD with count on stack
\ its OK to pass a transient prompt string in PAD
: REQUEST-STRING ( c-addr u1 -- u2 )
   !TEXT-STATE INPUT-SLAT NEW-SLAT
   TYPE PAD CHAR+ max-input ACCEPT
   DUP PAD C! .>>TEXT
;

\ release previously allocated memory
: ?DE-ALLOCATE ( -- )
   ALLOCATED IF
      TEXT FREE THROW
      LINES IF LINES FREE THROW THEN
      0 TO ALLOCATED
   THEN
;

\ * frees top doc-state in chain and moves to next
: POP-DOC-STATE ( -- )  \ Doc-State @ is next in chain
   Doc-State @ ?DUP IF  DUP @ Doc-State ! FREE THROW  THEN
;

\ * indicates whether the given item has a follower
: next? ( link-addr -- flag ) DUP IF @ TRUE? THEN ;

\ * returns the last link in the chain
\ returns a null chain address unchanged
\ NB. Never run this on a chain that is a closed loop
: last-link ( chain-addr -- last-link-addr )
   DUP IF BEGIN DUP @ DUP WHILE NIP REPEAT DROP THEN
;

\ * returns the address of the item pointing to the target
\ a target of 0 returns the last link
\ a null chain address or no target in chain returns FALSE
\ NB. Never run this on a chain that is a closed loop
: preceding-link ( chain-addr target-addr -- addr|FALSE )
   ?DUP IF
      >R DUP IF
         BEGIN DUP @ DUP R@ <> OVER TRUE? AND WHILE NIP REPEAT
      THEN R> = AND
   ELSE last-link
   THEN
;

\ * wraps chain around so first is last, second is first
\ passes null chain unchanged
: first-link>last ( chain-addr -- chain-addr )
   \ NB. Never run last-link on a closed chain
   \ must have a chain, and must have more than one in chain

   DUP next? IF
      DUP @ SWAP DUP DUP last-link ! OFF  \ first next -- next
   THEN
;


\ * wraps chain around so first is second, last is first
\ and second-last is now last; pass null chain unchanged
: last-link>first ( chain-addr -- chain-addr' )
   \ NB. never run preceding-link on a closed chain

   \ must have a chain, and must have more than one in chain
   DUP IF DUP @ IF

      \ current -- last last current last current
      DUP last-link TUCK 2DUP

      \ link current last to top, make second-last end
      preceding-link OFF !    \ -- original-last

   THEN THEN
;    


\ * moves doc-state to the next in the chain,
\ leaving the current as the new end of chain
\ nothing is done unless there are at least two in chain
: NEXT-DOC-STATE ( -- )
   Doc-State @ first-link>last Doc-State !
;


: PRIOR-DOC-STATE ( -- )
   Doc-State @ last-link>first Doc-State ! 
;    

\ * allocate memory from user input
: GET-TEXT-MEMORY ( -- )
   reserve-space @ ?DUP NOT IF
      0 CLEAR-PLANK
      ." >>> Reserve space for how many characters (K)?: "
      GET-INTEGER ?DUP 0= IF  Default-Allocate  THEN
      dup reserve-space !
   THEN
   K* DUP CHARS DUP ALLOCATE THROW
   TO TEXT  TO ALLOCATED  TO CMAX
;
\ allocate lines according to lines estimate
\ minimum lmax = cmax linewidth 2/ /
\ MF
VARIABLE lines-estimate
: ALLOCATE-LINES ( -- )
   lines-estimate @ DUP IF
      CMAX UM*  doc-size @  UM/MOD NIP
   THEN
   CMAX Linewidth 2/ U/ UMAX
   DUP 1+ CELLS
   DUP ALLOCATE THROW TO LINES
   ALLOCATED +  TO ALLOCATED  TO LMAX
;

\ * gives the address of a character position
: loc>addr ( loc# -- c-addr ) CHARS TEXT + ;

\ * gives the starting address of a line
: line>addr ( l# - c-addr ) LINE @ loc>addr ;

\ * translates a line index to an S string.
: line>s ( l# - c-addr u )   DUP line>addr SWAP LINELENGTH ;

\ * translates a character index to a character address
: spot ( -- a )  char-now @ loc>addr ;

\ * test a char value as a white space
: WS? ( c  -- flag )
\ FF HT and VT (if supported) might be additional `MOSTLY'
\ Other common delimiters are candidates for BARELY
   CASE
      BL    OF TRUE ENDOF
      FF    OF TRUE ENDOF
      HT    OF TRUE ENDOF
      'CR   OF MOSTLY ENDOF
      [CHAR] "
            OF BARELY ENDOF
               FALSE SWAP
   ENDCASE
;

\ * tests if there is whitespace at the current spot
: spot-ws? ( -- flag )  spot C@ WS? ;

\ * tests if a ws follows the current spot in the file
: next-spot-ws? ( -- flag )
   -DOC-END IF spot CHAR+ C@ WS? ELSE FALSE THEN
;

\ * translates char position and length to an S string
: t>mem ( c# u -- a u )  >R  loc>addr  R> ;

\ * stores a string in memory
: >text ( a u -- )
   TUCK  spot SWAP CMOVE  DUP char-now +!  col# +!
;

\ *** screen display **

CHAR - CONSTANT Command-Tab
CHAR + CONSTANT Text-Tab
CHAR * CONSTANT Transition-Tab
Command-Tab VALUE Current-Tab

\ * displays a tab section in a ruler line
: .tab ( -- )
   [CHAR] | EMIT
   Tabwidth 1- 0 MAX 0 ?DO Current-Tab EMIT  LOOP
;

\ * displays a line of tabs
: .tabs ( -- )
   tabs/line 0 ?DO .tab LOOP
;

\ display bottom ruler
\ I like responses down here. If you put them somewhere else,
\ make sure it prints each time in ``.RESULT'', below
: .REACT ( -- )
   REACT-SLAT NEW-SLAT .tabs 0 SLAT-Y .REACTION
;

\ blank a screen line
: RUB ( row -- )
   0 SWAP
   2DUP SLAT-XY  Max-X Ledge + SPACES  SLAT-XY
;

\ display current way of input
: .INSERT ( -- )     ." INSERT       " ;
: .OVERWRITE ( -- )  ." OVERWRITE    " ;
: .MARKING ( -- )    ." MARKING      " ;

' NOP VALUE (.WAY
: .WAY ( -- ) (.WAY EXECUTE
;
TRUE VALUE Commanding?  \ true = command mode
FALSE VALUE HELP-SHOWING?
VARIABLE HELP-SCREEN
HELP-SCREEN OFF

\ ** display command specific response
\ command specific response
: .TOF ( -- )       ." Top of file " ;
: .EOF ( -- )       ." Bottom of file " ;
: .SAVED ( -- )      ." Saved " ;
: .-SAVED ( -- )     ." Not saved " ;
: .looking ( -- )    ." Looking ... " ;
: .FOUND ( -- )      ." Found " ;
: .-FOUND ( -- )     ." NOT Found " ;
: .REPLACED ( -- )   ." Replaced " ;
: .REPLACE? ( -- )  ." Replace What? " ;
: .-ROOM ( -- )      ." Not enough room" ;
: .PLACEMARK ( -- )  ." Marker: " PLACEMARK TYPE SPACE ;
: .XMARKING ( -- )   ." Not when marking " ;

\ delete path from filename
: -PATH ( a1 u1 -- a2 u2 )
   PATH-DELIMITER TRAILING<>  DRIVE-DELIMITER TRAILING<>
;
\ display filename
: .FILENAME ( -- ) DS-NAME$ COUNT -PATH TYPE  SPACE ;

\ display filename, way, mode
: .HEADLINE ( a u -- ) .FILENAME .WAY  2 SPACES TYPE ;

: .ESCAPE-PREFIX ( -- ) Commanding? NOT IF ^COMMAND EMIT THEN ;

\ display help info
: .HELPLINE ( -- )
   HELP-SHOWING? IF
      S" to cycle through then close help"
   ELSE S" to get help"
   THEN .ESCAPE-PREFIX ^Help EMIT SPACE TYPE
;

\ display the headline
: .NEW-BANNER ( -- )
   Commanding? IF S" COMMANDING" ELSE S" TEXT ENTRY" THEN
   .HEADLINE 2 SPACES .HELPLINE
;

: .BANNER ( -- )
   .>INFO END-PLANK SLAT-Y .tabs   \ In case slat is 1 high
   0 SLAT-Y .NEW-BANNER .>>TEXT      \ Banner will cover ruler
;

\ Display a warning on the status line
\ Takes a prompt string: waits for key
: .WARNING ( c-addr u -- ) .>STATUS TYPE wait .>>TEXT ;

\ Takes a prompt string and counted string: waits for key
: .WARNING+NAME ( c-addr u cs -- )
   .>STATUS COUNT 2SWAP TYPE ." " TYPE wait .>>TEXT
;

\ ** response string shortcuts
: .TOF! ( -- )  ['] .TOF TO (.REACTION ;
: .EOF! ( -- )  ['] .EOF TO (.REACTION ;

\ display screen before displaying the document
: .SCREEN ( -- )
   FULL-SLAT @>SLAT CLEAR-SLAT
   .BANNER .REACT
   TEXT-SLAT @>SLAT 0 SLAT-Y
;
\ document display
BL VALUE "bl"     \ to EMIT  BL
BL VALUE "cr"     \ to EMIT 'CR
BL VALUE "other"  \ to EMIT other "invisible" character

\ 32 displays as "bl" , 13 displays as "cr"
: "INVISIBLE" ( c1 -- c2 )
   CASE
      BL OF "bl"  ENDOF
     'CR OF "cr"  ENDOF
            "other"
      SWAP
   ENDCASE
;

: ?DISPLAY ( c1 -- c2) DUP BL 1+ < IF "INVISIBLE" THEN ;

\ toggle visible and invisible "bl" AND "cr"
: ~DISPLAY ( -- )
   "cr" BL <>
   IF     BL TO "bl"   BL TO "cr"      BL TO "other"
   ELSE  .BL TO "bl"  .CR TO "cr"  .OTHER TO "other"
   THEN
   -1 top-old !
;

\ "highlighting"
' NOP VALUE (?MARK
: ?MARK ( c1 -- c2 ) (?MARK EXECUTE ;

\ display on leaving documment -- modify to suit
: .DONE ( -- )
   PRESERVE-STATE IF
      TEXT0-SLAT @>SLAT CLEAR-SLAT
      ." REWRITE to restart WRITER" CR
   ELSE
      FULL-SLAT @>SLAT
      END-PLANK CLEAR-PLANK
      END-PLANK ?DUP IF 1- CLEAR-PLANK THEN
   THEN
;
\ ** erasers **
\ display text lin
\ : LTYPE ( c# u -- )
\   TUCK t>mem
\   0 ?DO  COUNT  ?DISPLAY  ?MARK  EMIT  LOOP
\   DROP EraseEOL
\ ;
\ much faster ltype by Marcel Hendrix:
   \ columns per line is Max-X
   0 VALUE cnt
   CREATE lbuff  128 CHARS ALLOT
   : LTYPE ( c# u -- )
      0 TO cnt
      TUCK t>mem
      0 ?DO
         COUNT  ?DISPLAY  ?MARK
         lbuff cnt + C!  cnt 1+ TO cnt
      LOOP  DROP ( u )
      lbuff cnt Max-X 1- MIN TYPE
      ( u ) Max-X SWAP -  SPACES
   ;

\ line and page numbers
\ calculate page number
: PAGE-LINE ( l# -- p# n )  Lines/Page /MOD  1+ SWAP ;

\ which lines to display
VARIABLE .start   \ first
VARIABLE .end     \ last
VARIABLE .mend    \ override .end

: SET-REFRESH ( -- )
   top-line @ .start !  last-line @ DUP .end ! .mend !
;

\ * display a line of text in plank 
\ display line#, line
: .TLINE ( l# plank# -- )
   SLAT-Y
   LINESPEC ( char# length )
   Linewidth MIN LTYPE
;

\ * display some lines of text
: .TLINES ( -- )
   TEXT-SLAT @>SLAT
\   .start @ top-line @ MAX line-now @ MIN
   top-line @
 
   .end @ .mend @ MAX  last-line @ MIN  BOTTOMLINE MIN
   
   OVER -  1+  0 ?DO
     DUP I .TLINE 1+
   LOOP
   DROP
   last-line @ top-line @ - 1+ CLEAR-SLAT>>
;

\ ** formatting
\ * Only a stub: comment word-wrap not yet implemented
0 VALUE LINE-MARGIN
64 VALUE DEFAULT-LINE-MARGIN
: GET-MARGIN ( -- )
   S" Margin at Column? " REQUEST-INTEGER
   ?DUP IF CHARS/LINE UMIN ELSE DEFAULT-LINE-MARGIN THEN
   TO LINE-MARGIN
;

FALSE VALUE FORMAT-ALL  \ true = format the entire document
FALSE VALUE SAME        \ true if line data hasn't changed
VARIABLE format-line          \ line being formatted

\ 'CR a special case
: CReturn ( a -- )
   format-line @ TUCK  1+ LINE @  2DUP <> IF
      < IF  LINES>  ELSE  <LINES  THEN
      last-line @ .mend !
   ELSE 2DROP DROP
   THEN
;

\ formatting old ground?
: ?SAME ( c# 'line -- )
   FORMAT-ALL IF
      2DROP
   ELSE
      @ = IF
         format-line @  line-now @  OVER U<
         OVER LINELENGTH Linewidth U< AND AND
         ?DUP IF 1- .end !  TRUE TO SAME  THEN
      THEN
   THEN
;

\ store a character position in the next line
: LINE! ( c# -- )  format-line DUP INCR @ LINE  2DUP ?SAME ! ;

\ MF doesn't wrap, so LF's WRAP became MF's >CR
Linewidth 1+ CONSTANT Linewidth+

: >CR ( c#1 a u -- c#2 )
   2DUP CHARS/LINE MIN
   'CR -LEADING<> IF                   \ look for first CR
      NIP SWAP - 1+ +
      DUP CReturn  DUP LINE!           \ end of line
   ELSE
      DROP NIP DUP CHARS/LINE = IF     \ else = maxlength?
         + DUP LINE!                   \ ( c# )
      ELSE +                           \ last line, no CR
      THEN
   THEN
;

\ clean-up after formatting
: DEJA? ( -- )
   SAME IF
      last-line DUP @ format-line @ 1- MAX SWAP !
      doc-size @ last-line @ 1+ LINE !
   ELSE
      last-line @ 1+ format-line @  DUP last-line !  DUP .end !
      1+ doc-size @ OVER LINE !  1+ SWAP 0LINES
   THEN
;
\ the f word
: FORMAT ( -- )
   FALSE TO SAME  line-now @  DUP format-line !
   LINE @
   BEGIN
      DUP DUP CHARS/LINE +  doc-size @ UMIN
      OVER - t>mem >CR
      DUP doc-size @ = SAME OR
   UNTIL DROP DEJA?
;

: FORMAT-EVERYTHING ( -- )
   TRUE TO FORMAT-ALL  FORMAT  FALSE TO FORMAT-ALL
;

\ *** moving around in the document **
\ cursor right
: RIGHT ( -- )
   -DOC-END IF char-now INCR ELSE ?BEEP .EOF! THEN
;

\ cursor left
: LEFT ( -- )
   char-now @ IF char-now DECR ELSE ?BEEP .TOF! THEN
;

\ stop on first & last ws of string of ws,
\ first character of string of text
\ NB. If you change these previous, you must
\ update WORD-START

: WORD-RIGHT ( -- )
   DOC-END IF EXIT THEN
   line-now @
   spot-ws? DUP next-spot-ws? AND SWAP
   LEFT BEGIN
      RIGHT spot-ws? TUCK XOR
      DOC-END OR
   UNTIL DROP EXACT? IF LEFT THEN
   char-now @ SWAP C>L line-now !
;

: WORD-LEFT ( -- )
   char-now @ 0= IF EXIT THEN
   char-now @ 1 = IF LEFT EXIT THEN
   LEFT spot-ws? BEGIN
      LEFT spot-ws? TUCK XOR
      char-now @ 0= OR
   UNTIL NOT IF RIGHT THEN
;

\ * WORD-START is for words which take input strings from text
\ position spot at left edge of current text string
: WORD-START ( -- )
   spot-ws? IF WORD-RIGHT ELSE WORD-LEFT THEN
   spot-ws? IF WORD-RIGHT THEN
;

: TEXT-STRING ( -- c-addr u )
   WORD-START spot WORD-RIGHT WORD-RIGHT spot OVER -
;

\ calculate the column of the current character
: CPLACE ( -- col# )  char-now @  line-now @ LINE @ - ;

\ calculate where to place the cursor in a line
: >char-now ( cplace l# -- )
   LINESPEC  ROT 2DUP U< IF
      DROP  1-  0 MAX
   ELSE NIP
   THEN + char-now !
;

\ cursor up
: UP ( -- )
   line-now @ IF
      CPLACE line-now DUP DECR @ >char-now
   ELSE ?BEEP .TOF!
   THEN
;

\ cursor down
: DOWN ( -- )
   line-now @ last-line @ U< IF
      CPLACE line-now DUP INCR @ >char-now
   ELSE
      ?BEEP .EOF!
   THEN
;

\ *** text pushes and pulls **
\ number of characters to the end of the document
: #>END ( a -- u )
   TEXT -  /CHAR U/
   doc-size @ deletes-length @ +
   SWAP -
;

\ suture text separated by u chars
: JOIN ( u -- )  CHARS spot DUP UNDER+  OVER #>END CMOVE ;

\ prepare to delete u characters
: <#SLIDE ( u -- )
   doc-size @ IF
      DUP JOIN NEGATE doc-size +!
   ELSE DEEP
   THEN
;

\ prepare to delete character
: <SLIDE ( -- )  1 <#SLIDE  -1 LINES+! ;

\ make room for u characters
: SPLIT ( u -- )  CHARS  spot  TUCK +  OVER #>END  CMOVE> ;

\ prepare to insert u characters
: #SLIDE> ( u -- )
   DUP ROOM? IF
      DUP SPLIT  doc-size +!
   ELSE DEEP
   THEN
;

\ prepare to insert character
: SLIDE> ( -- )  1 #SLIDE>  1 LINES+! ;

\ *** text input **

0 VALUE PREVIOUS-KEY \ two keys needed to enter command mode
0 VALUE HIDDEN-CHAR  \ character overwritten by ^command character

\ put character into the document
: OVERWRITE ( c -- )
   char-now @ CMAX U<  line-now @ LMAX U< AND IF
      spot C! doc-size DUP @ char-now DUP INCR @ UMAX SWAP !
      FORMAT
   ELSE DEEP
   THEN
;

\ insert character into the document
: INSERT ( c -- )
   1 ROOM?  last-line @ LMAX U< AND
   line-now @ LMAX 1- U< AND IF
      -DOC-END IF SLIDE> THEN
      OVERWRITE
   ELSE ['] .-ROOM TO (.REACTION DEEP
   THEN
;

\ delete character
: DELETE ( -- ) -DOC-END IF <SLIDE FORMAT ELSE ?BEEP .EOF! THEN ;

\ delete the previous character
: <DELETE ( -- )
   char-now @ IF
      line-now @ 1- 0 MAX line-now !
      LEFT DELETE
   ELSE ?BEEP .TOF!
   THEN
;

\ delete/undelete line
50 CONSTANT MAX-DELETES  \ more if you like
VARIABLE lines-deleted   \ number of deleted lines

\ ** deleted-lines stack holds length of each deleted line
CREATE DELETED-LINES  MAX-DELETES CELLS ALLOT

: 0DELETED-LINES ( -- )
   0 lines-deleted !
   DELETED-LINES MAX-DELETES CELLS ERASE
;

\ lengths of deleted lines added together
: SUM-DELETED ( -- )
   0 lines-deleted @ 0 ?DO
      DELETED-LINES I CELLS +  @  +
   LOOP deletes-length !
;

\ save length of deleted line to stack
\ line > max-deletes is lost
: PUSH-LINE ( u -- )
   lines-deleted @
   CELLS DELETED-LINES + !
   lines-deleted INCR
   SUM-DELETED
;

\ retrieve length of the last deleted line from the stack
: POP-LINE ( -- u )
   lines-deleted @ IF
      lines-deleted
      DUP DECR @ CELLS DELETED-LINES +  @
   THEN
   SUM-DELETED
;

\ a is spot
\ u1 is doc-size+deleted-lines
\ u2 is length of line to be deleted/undeleted
\ uses in-buffer
: CROSS-OUT ( a u1 u2 -- )
   >R
   OVER IN-BUFFER R@ CMOVE
   2DUP R@ /STRING 2OVER DROP SWAP CMOVE
   R@ - CHARS + IN-BUFFER SWAP R> CMOVE
;

: CROSS-IN ( a u1 u2 -- )
   >R
   2DUP R@ - CHARS + IN-BUFFER R@ CMOVE
   2DUP R@ - OVER R@ CHARS + SWAP CMOVE>
   DROP IN-BUFFER SWAP R> CMOVE
;

\ forget max-deleted-th line
: ?OBLIVIAN
   lines-deleted @ MAX-DELETES = IF
      DELETED-LINES @ >R
      doc-size @ loc>addr
      DUP R@ CHARS + SWAP
      deletes-length @ R> - CMOVE
      DELETED-LINES CELL+ DELETED-LINES
      MAX-DELETES 1-  CELLS MOVE
      lines-deleted DECR
      SUM-DELETED
   THEN
;

\ delete line and put it after previous deleted lines
: CUT-LINE ( -- )
   doc-size @ IF
      ?OBLIVIAN
      line-now @ LINESPEC >R
      char-now ! spot DUP #>END
      R@ CROSS-OUT
      R> DUP PUSH-LINE
      NEGATE DUP LINES+!  doc-size +!
      FORMAT
   ELSE ?BEEP
   THEN
;

\ paste in last deleted line
: PIN-LINE
   lines-deleted @ IF
      line-now @ LINE @  char-now !
      spot DUP #>END
      POP-LINE  >R
      R@ CROSS-IN
      R> DUP LINES+!  doc-size +!
      FORMAT
   ELSE ?BEEP
   THEN
;

\ Enter key
\ smart indenting
: smart-indent ( -- )
   line-now @ LINESPEC t>mem  BL LEADING= NIP
   0 ?DO  BL INSERT  LOOP
;

' NOP VALUE (?smart-indent
: ?smart-indent ( -- ) (?smart-indent EXECUTE ;
: ?smart-indents ( -- )
   Smart-Indents IF
      ['] smart-indent TO (?smart-indent
   ELSE
      ['] NOP TO (?smart-indent
   THEN
;

\ inserting:  put in a paragraph end in text mode
\              fall into text mode from command mode
\ *****
: PARAGRAPH ( -- )
   last-line @ LMAX 1- U< IF
      'CR INSERT ?smart-indent
   ELSE ?BEEP
   THEN
;

\ overwriting:  if not at document's end go to the next
\ line, else insert a paragraph end
: RETURN ( -- )
   -DOC-END IF
      line-now @ LINE @ char-now ! DOWN
   ELSE
      MARKING? NOT IF PARAGRAPH ELSE ?BEEP THEN
   THEN
;

\ ** Tab
CREATE TAB$  HERE  Tabwidth DUP CHARS ALLOT  BLANK
CREATE TABLINE$ Linewidth CHARS ALLOT
CHAR - CONSTANT ^TabOff
CHAR + CONSTANT ^TabOn

: FIXED-TAB ( -- )
   TABLINE$ Linewidth ^TabOff FILL
   Linewidth CHARS TABLINE$ DUP UNDER+ ?DO
      ^TabOn I C!
   Tabwidth CHARS +LOOP
;
FIXED-TAB

\ #cols to next tab mark
: NEXT-TAB ( -- n )
   Tabwidth  col# @ Tabwidth MOD  - ;

\ tab while inserting
\ will sometimes fall short of the first tab mark but
\ but will go to it with the next tab
: NUDGE ( -- )
   NEXT-TAB
   DUP ROOM? IF
      DUP >R #SLIDE>  TAB$ spot R@ CMOVE
      R>  DUP LINES+!  char-now +!  FORMAT
   ELSE DEEP
   THEN
;

\ tab while overwriting
: HOP ( -- )
   -DOC-END IF
      NEXT-TAB
      char-now @ +
      line-now @ 1+ LINE @ MIN
      doc-size @ 1+ UMIN  char-now !
   ELSE NUDGE
   THEN
;

\ *** jumps **
\ keep jumped to line within document
: CONFINE ( l1 -- l2 )  0 last-line @ CLAMP
;

\ keep current line in screen within n lines of top
: AIM ( c# n -- )
   SWAP 0 C>L TUCK DUP DUP line-now !  \ now n now now
   ROT MIN -                           \ now [now-min(n,now)]
   top-line @ MAX MIN top-line !
;

\ go to l# line in screen within n lines of top
: AIM>LINE ( l# n -- )
   >R CONFINE LINE @ DUP char-now ! R> AIM
;

0 VALUE LINE-TARGET

: >TARGET ( -- )  LINE-TARGET PLANKS 2/ AIM>LINE ;

: GET-TARGET ( -- )
   S" Target Line Number? " REQUEST-INTEGER
   1- CONFINE TO LINE-TARGET >TARGET
;

\ jump n lines
: JUMP ( n -- )
   DUP top-line @ + CONFINE top-line !
   CPLACE SWAP line-now @ + CONFINE
   DUP line-now ! >char-now
;

\ jump down
: +JUMP ( u -- )
   line-now @ last-line @
   = IF DEEP .EOF! ELSE JUMP THEN
;

\ jump up
: -JUMP ( u -- )
   line-now @
   0= IF DEEP .TOF! ELSE NEGATE JUMP THEN
;

\ jump to the beginning of the line
: <LEFT ( -- )   line-now @ LINE @ char-now ! ;

: HOME-LEFT ( -- )   col# @ IF <LEFT ELSE UP THEN ;

\ jump to the end of the line
: RIGHT> ( -- )
   line-now @
   DUP 1+ LINE @  1-
   SWAP last-line @ = 1 AND  +  char-now !
;

: HOME-RIGHT (  -- ) spot C@ 'CR = IF DOWN THEN RIGHT> ;

\ jump to the start of the document
: >TOF ( -- ) 0 char-now ! 0 line-now ! 0 top-line ! .TOF! ;

\ jump to the end of the document
: >EOF ( -- )
   doc-size @ char-now !
   last-line @ DUP line-now ! DUP .end !
   DUP top-line @ PLANKS + 1- > IF
      SLAT-PAN - DUP .start !  top-line !
   ELSE DROP
   THEN .EOF!
;

\ jump to current top screen line or up a screen
: JUMP-UP ( -- )
   top-line @ line-now @ U< IF \ simplify: top-line == 0
      CPLACE  top-line @  DUP line-now !  >char-now
   ELSE
      line-now @ IF
         SLAT-PAN -JUMP
      ELSE
         .TOF! ?BEEP
      THEN
   THEN
;

\ jump to current bottom screen line or down a screen
: JUMP-DOWN ( >BOTTOM ) ( -- )
   line-now @ DUP last-line @ U< IF
      BOTTOMLINE U< IF
         CPLACE last-line @ BOTTOMLINE MIN
         DUP line-now !  >char-now
      ELSE
         SLAT-PAN +JUMP
      THEN
   ELSE DEEP .EOF!
   THEN
;

\ ~insert
\ toggle insert/overwrite
: ~INSERT ( -- )  way# DUP @ 1 XOR SWAP ! ;

\ *** find/replace **
CREATE S$  max-input CHARS ALLOT  \ search string
CREATE R$  max-input CHARS ALLOT  \ replace string
FALSE VALUE FOUND    \ has search string been found?
VARIABLE found-char  \ where?
VARIABLE slen        \ length of search string
VARIABLE spad>       \ offset in PAD of found string
VARIABLE rlen        \ length of replace string

: REPLACE-CHANGE ( -- n ) rlen @ slen @ - ;

: REPLACE-INCREASE ( -- u ) REPLACE-CHANGE 0 MAX ;

\ string to search string
: S>S$ ( c-addr u -- ) DUP slen ! S$ SWAP CMOVE ;

\ does the string have an uppercase character?
: UC? ( a u -- f )
   0 ?DO  COUNT [CHAR] A [CHAR] Z
          BETWEEN IF  DROP TRUE  UNLOOP EXIT  THEN
      LOOP DROP  FALSE
;
\ does the string have a lowercase character?
: lc? ( a u -- f )
   0 ?DO  COUNT [CHAR] a [CHAR] z
          BETWEEN IF  DROP TRUE  UNLOOP EXIT  THEN
     LOOP DROP  FALSE
;

\ * tests if the string has upper- and lower-case characters
: MIXED-CASE? ( a u -- f )  2DUP UC? >R  lc?  R> AND ;

' 2DROP VALUE ?s>lower  \ "deferred" ?s>lower

\ * makes string lower case if NOT MIXED-CASE
: ?MIXED-CASE ( a u -- )
   2DUP
   MIXED-CASE? IF ['] 2DROP ELSE ['] s>lower THEN
   TO ?s>lower  ?s>lower EXECUTE
;

\ * looks for searched string in search pad
: looking ( a u -- )
   2DUP ?s>lower EXECUTE  S$ slen @ SEARCH
   NIP ?DUP IF
      TO FOUND  search-pad - spad> !
   ELSE DROP
   THEN
;

\ you can't go home again (i.e. you can go home once)
TRUE VALUE OK-TO-GO-HOME  \ ok to loop back to TOF?
VARIABLE snow             \ char# now at search-pad

\ move some text to the search pad
: t>spad ( a u -- spad u )
   t>mem  >R
   search-pad R@ CMOVE
   search-pad  R>
;

\ search text for a string, if it isn't found,
\ continue to look from the beginning of the document
: SWEEP ( -- )
   TRUE TO OK-TO-GO-HOME
   doc-size @ >R
   char-now @ 1+ DUP R@ 1+ slen @ - U< AND
   BEGIN
      DUP snow !  DUP  DUP GULP +  R@ UMIN  DUP >R
      OVER - t>spad looking
      R> R@ = OK-TO-GO-HOME AND IF
         DROP 0  FALSE TO OK-TO-GO-HOME
      ELSE
         GULP slen @ 1- - +
      THEN
      DUP char-now @ 1+ U<  OK-TO-GO-HOME  OR 0=  FOUND OR
   UNTIL
   R> 2DROP
;

\ if the string found identify the starting character
\ if necessary ensure that it can be displayed
: ?FOUND ( -- )
   FOUND IF
      ['] .FOUND TO (.REACTION
      snow @ spad> @ +
      DUP char-now !  DUP found-char !
      PLANKS 3 4 */ AIM
   ELSE  ['] .-FOUND TO (.REACTION ?BEEP
   THEN
;

: CS>PIECES ( c-addr addr cs-addr -- )
   COUNT DUP >R ROT ! R> CMOVE
;

\ the seek word
: SEEK ( -- )
   ['] .looking TO (.REACTION
   FALSE TO FOUND
   slen @ ?DUP IF
      doc-size @ 1+ U< IF
         S$ slen @ ?MIXED-CASE SWEEP
      THEN
   THEN
   ?FOUND
;

\ seek using string & count on stack
: S-SEEK ( c-addr u -- )
   DUP max-input > IF               \ max-input<u?
      2DROP S" Text too long for seach buffer." .WARNING
   ELSE DUP slen ! S$ SWAP CMOVE SEEK
   THEN
;

\ seek with prompt -- empty string seeks the previous string
: SEEK? ( -- )
   S" Find: " REQUEST-STRING IF
      PAD COUNT S-SEEK
   ELSE SEEK
   THEN
;

\ was something found here?
: POINT? ( -- f )  FOUND  char-now @ found-char @ = AND ;

\ adjust for difference between sought and replace lengths
: SLIDE ( n -- )
   DUP 0< IF
      NEGATE <#SLIDE
   ELSE #SLIDE>
   THEN
;

\ replace
: PUT ( -- )
   POINT? IF
      REPLACE-INCREASE ROOM? IF
         REPLACE-CHANGE ?DUP IF DUP SLIDE LINES+!  THEN
         R$ spot rlen @ CMOVE  FORMAT
         ['] .REPLACED TO (.REACTION
      ELSE
         DEEP  ['] .-ROOM TO (.REACTION
      THEN
      FALSE TO FOUND
   ELSE
      ['] .REPLACE? TO (.REACTION
   THEN
;

: S-PUT ( c-addr u -- ) DUP rlen ! R$ SWAP CMOVE PUT ;

: PUT? ( -- )
   POINT? IF
      S" Replace with: " REQUEST-STRING IF
         PAD COUNT S-PUT
      ELSE PUT
      THEN
   ELSE
      ?BEEP  ['] .REPLACE? TO (.REACTION
   THEN
;

\ insert text from the command line
: STUFF ( -- )
   S" Wedge in: " REQUEST-STRING
   DUP ROOM? AND IF
      PAD COUNT TUCK  DUP SLIDE DUP LINES+!
      spot SWAP CMOVE
      FORMAT char-now +!
   THEN .BANNER
;

\ *** placemarks **

: .MARKER-RESPONSE ( -- ) ['] .PLACEMARK TO (.REACTION ;

: MARK-PLACE ( -- )
   <LEFT PLACEMARK 0 ?DO
      DUP I CHARS + C@ INSERT
   LOOP DROP
   PARAGRAPH LEFT .MARKER-RESPONSE
;

\ marker lines of various lengths can work like outlines
\ except that "\ **" is 'outside' of "\ *", because longer
\ marker lines restrict the search and shorter marker lines
\ widen the search

: TO-MARKER ( n -- ) TO PLACE-DEPTH .MARKER-RESPONSE ;

: INCR-MARKER ( -- ) PLACE-DEPTH 1+ MAX-MARKER MIN TO-MARKER ;

: MAX-TO-MARKER ( -- ) MAX-MARKER TO-MARKER ;

: DECR-MARKER ( -- ) PLACE-DEPTH 1- MIN-MARKER MAX TO-MARKER ;

: MIN-TO-MARKER ( -- )   MIN-MARKER TO-MARKER ;

: PLACE-LINE? ( l# -- flag )
   LINE @ loc>addr PLACEMARK 0 ?DO
      OVER I + C@ OVER I + C@
      <> IF 2DROP UNLOOP FALSE EXIT THEN
   /CHAR +LOOP
   2DROP TRUE
;

: PLACE-BLOCK? ( l#-end l#-start -- l#-match flag )
   2DUP U> IF
      ?DO
         I PLACE-LINE? IF
           I TRUE UNLOOP EXIT
         THEN
      LOOP
   ELSE 2DROP
   THEN 0 FALSE
;

: SEEK-PLACE ( -- )
   last-line @ line-now @ 1+ PLACE-BLOCK? IF
      TRUE
   ELSE
      line-now @ 0 PLACE-BLOCK?
   THEN IF
      LINE @ DUP char-now !
      PLANKS 2/ AIM
      .MARKER-RESPONSE
   ELSE
      DEEP  ['] .-FOUND TO (.REACTION
   THEN
;

\ *** marking a block **
VARIABLE way#-was \ way# before marking
VARIABLE bstart   \ where marking originated
VARIABLE .bstart  \ beginning of marked text
VARIABLE .bend    \ end of marked text
VARIABLE blength  \ number of characters in the block
VARIABLE btop     \ top block line to display

\ current char index, pulled into the doc if needed
: BLOCK-IN ( -- n )
   char-now
   DUP @ doc-size @ 1- UMIN TUCK SWAP !
;

\ if marking, define marked area
: <BLOCK> ( -- )
   BLOCK-IN bstart @
   2DUP UMIN .bstart ! UMAX 1- .bend !
   line-old @ line-now @  2DUP MIN .start !  MAX .end !
;

\ start and end characters of the block (DO LOOP order)
: .BFRAME ( -- loc-end loc-start )  .bend @ .bstart @ ;

\ block as a c-addr u string
: MARKED-STRING ( -- c-addr u )
   .BFRAME DUP loc>addr -ROT - 1+ 
;

\ start and end lines of the block
: <LL> ( -- l1 l2)  .BFRAME 0 C>L  TUCK C>L ;

\ would like a Standard way to highlight:  GLOW ?
: MARK ( a c -- a c)
   OVER 1-
   .BFRAME loc>addr SWAP loc>addr
   BETWEEN IF >EMPHASISED THEN
;

' NOP VALUE (?BLOCK
: ?BLOCK ( -- ) (?BLOCK EXECUTE ;

\ leave marking
: -MARK ( -- )
   <LL> .end !  .start !  way#-was @ way# !
   ['] NOP DUP TO (?MARK TO (?BLOCK
   .BANNER
;

\ start marking: if marking, kill old and start over
: +MARK ( -- )
   MARKING? IF -MARK THEN
   way# DUP @ way#-was !  2 SWAP !
   ['] MARK TO (?MARK
   ['] <BLOCK> TO (?BLOCK
   BLOCK-IN  bstart !  top-line @ btop !
   -1 top-old !  .BANNER
;

: +MARK-WORD ( -- ) +MARK WORD-RIGHT ;

: SEEK-MARKED ( -- )    MARKED-STRING -MARK S-SEEK ;

: SEEK-WORD ( -- )     TEXT-STRING S-SEEK ;

: FIRST-MARKED ( -- )  MARKED-STRING -MARK >EOF S-SEEK ;

: FIRST-WORD ( -- )    TEXT-STRING >EOF S-SEEK ;

\ *** copy, cut, embed **
\ fits into allotted space?
: SMALL? ( u -- flag )  Pocket-Size 1+ < ;

\ write larger block to a temporary file
\ MF
: >PURSE ( a u -- ) S" temp.mf" CREATE-WRITE >FILE ;

\ copy marked
: APE ( -- )
   MARKED-STRING DUP blength ! DUP SMALL? IF
      POCKET  SWAP CMOVE
   ELSE >PURSE
   THEN -MARK
;

\ copy and delete
: CUT ( -- )
   APE
   .BFRAME DUP char-now !
   DUP 0 C>L  DUP .start !  line-now !
   - 1+ DUP <#SLIDE NEGATE LINES+!  FORMAT
   btop @ top-line @ U< IF
      btop @ top-line !
   THEN last-line @ .end !
;

\ slip in a file
: SLIP ( -- )
   BEGIN
      FILE-LINE WHILE
         0 col# !
         BEGIN
            DUP WHILE
               2DUP HT -LEADING<>
               TUCK  2>R -  DUP #SLIDE>  >text
               2R> DUP IF
                  TAB$ NEXT-TAB
                  DUP #SLIDE>  >text
                  1 /STRING
               THEN
         REPEAT 2DROP
   REPEAT 2DROP <DELETE
   FCLOSE
;

\ read large cut block
: PURSE> ( -- ) S" temp.mf" OPEN-READ SLIP ;

\ paste copied or cut block
: PASTE ( -- )
   blength @ DUP DUP ROOM? AND
   <LL> SWAP - last-line @ + LMAX U< AND IF
      ['] NOP TO (.REACTION
      DUP >R SMALL? IF
         R@ #SLIDE> POCKET spot  R@ CMOVE  R@ LINES+!
         R@ char-now +!
      ELSE PURSE>
      THEN
      R> DROP FORMAT-EVERYTHING
      char-now @  PLANKS 2/ AIM
   ELSE
      ['] .-ROOM TO (.REACTION DEEP
   THEN
;

\ *** file i/o **
\ number of chars to dot
: >DOT ( s -- n )  COUNT [CHAR] . -TRAILING<> NIP ;

\ move name to filename
\ file?
\ ****
: GET-FILENAME ( -- a u) DS-NAME$ COUNT ;
: ?FILENAME ( -- )
   S" Filename: "  REQUEST-STRING IF PUSH-DOC-STATE THEN
;

\ save file
: FSAVE ( s -- )
   COUNT CREATE-WRITE
   TEXT doc-size @ >FILE
   ['] .SAVED TO (.REACTION
;
\ save the document
: SAVE-DOC ( -- )    DS-NAME$ FSAVE ;

\ name of clipfile
CREATE CLIPNAME$  max-input 6 + CHARS ALLOT  \ filename string
S" CLIPFILE.txt" CLIPNAME$ S>CS

\ name of dynamic forth source file

S" TEMPSRC.fs" CREATE TEMPSOURCE$
DUP 1+ CHARS ALLOT TEMPSOURCE$ S>CS

\ save marked to current file
: SAVE-MARKED-BLOCK ( -- u )  MARKED-STRING >FILE -MARK ;

\ add to the clipping file
: CLIP-MARKED ( -- u )
   CLIPNAME$ COUNT OPEN-APPEND SAVE-MARKED-BLOCK
;
\ add to named clipping file (use existing if no name given)
: CLIP-MARKED-AS ( -- u )
   S" Clip marked to: " REQUEST-STRING IF
      PAD CLIPNAME$ SMOVE
   THEN CLIP-MARKED
;
\ Save current line
: SNIP ( -- )
   CLIPNAME$ COUNT OPEN-APPEND line-now @ line>s >FILE
;

: SNIP-AS ( -- u )
   S" Clip as: " REQUEST-STRING IF
      PAD CLIPNAME$ SMOVE
   THEN SNIP
;

: SAVE-MARKED-AS ( -- u )
   S" Save marked as: " REQUEST-STRING IF
      PAD COUNT CREATE-WRITE SAVE-MARKED-BLOCK
   ELSE S" This operation requires a file name." .WARNING
   THEN
;

\ read in the document from a file
: READ ( -- )
   FILE-ID FILE-SIZE THROW
   SWAP CMAX U< 0= OR ABORT" FILE TOO BIG"
   0 lines-estimate !
   BEGIN    FILE-LINE
   WHILE
      lines-estimate INCR  0 col# !
      BEGIN    DUP
      WHILE
         2DUP HT -LEADING<>
         LEADING-SUBSTRING >text DUP IF
            TAB$ NEXT-TAB >text  1 /STRING
         THEN
      REPEAT 2DROP
   REPEAT 2DROP FCLOSE
   char-now @ doc-size !
;

\ * if there's a file read it, else create a file
: ?READ ( a u -- )
   OPEN-READ READ ALLOCATE-LINES  0>LMAX
;

\ prompt for a filename, try to read the file
: GET-DOCUMENT ( -- ) GET-FILENAME ?READ ;

\ save a marked block (do nothing if no name given)
: S-FROM ( c-addr u -- flag )
   TRUE -ROT               \ presume problem, replace if all OK
   OPEN-READ 
   FILE-ID FILE-SIZE IF
      S" FILE-SIZE problem" .WARNING
   ELSE
      OVER ROOM? 0= OR IF
         DROP S" NOT ENOUGH ROOM " .WARNING
      ELSE
         DROP SLIP FORMAT-EVERYTHING
         char-now @  PLANKS 3 4 */ AIM
         DROP FALSE
      THEN
   THEN
;

\ Fetch a file
: FROM> ( -- )
   S" Read from: " REQUEST-STRING IF
      PAD COUNT S-FROM DROP
   THEN
;

: FROM-CLIP ( -- ) CLIPNAME$ COUNT S-FROM DROP ;

\ do a backup
: BACKUP ( -- )
   PAD Pad-Space BLANK
   DS-NAME$ PAD SMOVE  PAD >DOT
   ?DUP IF 1- PAD C! THEN
   S" .bak" PAD S+!  PAD FSAVE
;

\ * if the file has some data, back it up
: ?BACKUP ( -- ) doc-size @ IF BACKUP THEN ;

\ * change filename
: ~NAME ( -- )
   S" Change filename to: " REQUEST-STRING IF
      PAD DS-NAME$ SMOVE  DS-NAME$ FSAVE
   THEN .BANNER
;

\ *** scrolling **
\ * scroll up one line
: SCRUP ( -- )
   top-line DUP INCR @ .start !  last-line @ .end !
;

\ scroll down one line
: SCROWN ( -- )
   top-line DUP DECR @ .start !  last-line @ .end !
;

\ do I need to scroll?
: SCROLL? ( row#1 -- row#2 )
   DUP END-PLANK > IF
      SCRUP DROP END-PLANK top-line @ top-old !
   ELSE
      DUP 0< IF
         SCROWN  1+  top-line @ top-old !
      THEN
   THEN
;

\ where to put the cursor
: !CURSOR ( -- )
   char-now @
   DUP line-now @ 1- 0 MAX C>L  DUP line-now !
   DUP >Y SCROLL? -ROT LINE @ - DUP col# !
   DUP Linewidth - NEXT-TAB +  0 MAX
   DUP .col @ <> IF
      top-line @ .start !  last-line @ .end !
   THEN DUP .col ! -
   SWAP cursor> 2!
;

' !CURSOR TO (!TEXT-STATE

\ * Make cursor match cursor>
: @CURSOR ( -- )
   TEXT-SLAT @>SLAT
   cursor> 2@ SLAT-XY
;

' @CURSOR TO (@TEXT-STATE   

\ * should I redisplay the entire text area?
: ?FRAME ( -- )
   top-line @ top-old @ <> IF
      top-line @ .start !  last-line @ .end !
   THEN
;

\ ** .status
\ display of and the statistic
: .OF ( n -- )  [CHAR] / EMIT U. ;

\ display max
: .MAX ( n -- ) [CHAR] m EMIT U. SPACE ;

\ display status line
: .STATUS-LINE ( -- )
   [CHAR] C EMIT SPACE  char-now @ 1+ U.
   doc-size @ 1+ .OF  CMAX .MAX
   last-line @ line-now @
   [CHAR] L EMIT SPACE 1+ U.  1+ .OF  LMAX .MAX
   ." Col "  col# @ 1+ U.
;

: .STATUS ( -- ) AT-STATUS CLEAR-SLAT .STATUS-LINE ;

\ .result
: .RESULT ( -- )
   !CURSOR  ?FRAME
   .TLINES  .STATUS  .REACT
   @CURSOR
;

\ And with the .RESULT we are able to show what we have:
: REFRESH-DISPLAY ( -- ) SET-REFRESH .SCREEN FORMAT ;

: ?OLD-PLACE ( -- flag )
   old-place 2@ OR IF
       old-place 2@ AIM 0 0 old-place 2!
   THEN REFRESH-DISPLAY
;

: START-DISPLAY ( -- ) >TOF REFRESH-DISPLAY ?OLD-PLACE ;   

\ *** do-forth **
: DO-INPUT ( c-addr u -- )
   S" Forth command: " REQUEST-STRING DROP
   .>REACT ." Result: " 
   PAD COUNT EVALUATE
   INPUT-SLAT NEW-SLAT wait
   .>>TEXT
;

\ add to the clipping file
: DO-MARKED ( -- )
   TEMPSOURCE$ COUNT CREATE-WRITE
   SAVE-MARKED-BLOCK
   .>TEXT ." Result: " CR 
   TEMPSOURCE$ COUNT INCLUDED
   INPUT-SLAT NEW-SLAT wait
   .>>TEXT REFRESH-DISPLAY
;

\ *** begin and end **
\ new-text memory
\ allocate for text; space for lines data
\ will be estimated after reading in the file

: NEW-TEXT ( -- )
   GET-TEXT-MEMORY
   INIT-STATE-VARIABLES  0 way# !
   BL TO "bl"     BL TO "cr"     BL TO "other"
   FALSE TO FOUND
   0DELETED-LINES
   ['] NOP  DUP TO (?MARK  TO (?BLOCK
;
\ yes, Leo wrote most of this
: {c} ( -- )
   \ Don't care if dimensions have changed,
   \ but want them up-to-date
   DIMENSIONS? DROP 2DROP
   CLEAR-SLAT
    3  3 SLAT-XY ." BMW (Bruce McFarling's WRITER) v0.0.8"
    3  4 SLAT-XY ." Primarily based upon:"
    5  5 SLAT-XY ." MF v1.0  "
               ." Copyright 1997 Leo Wong.  All rights reserved."
    3  6 SLAT-XY ." Any work original to BMW copyright 1997--99 "
               ." Bruce McFarling."
    3  7 SLAT-XY ." All residual rights reserved."
;
\ our story begins

: START ( -- )
   FALSE TO SWITCH-STATE
   FALSE TO PRESERVE-STATE
   TRUE TO Commanding?
   (.NORMAL TO (.REACTION
   NEW-TEXT ?BEEPS ?smart-indents ?DEBUG
   GET-DOCUMENT START-DISPLAY ?BACKUP
;

\ ** Finish
\ * offer to save before leaving
: OFFER-TO-SAVE ( -- )
   INPUT-SLAT NEW-SLAT ." Save " .FILENAME ." (Y/n)?"  in-key
   AND BL OR [CHAR] n <> IF  SAVE-DOC  THEN
;

\ * frees up memory, pop the document state and
\ signal switch to main loop
: FINISH ( -- )
   OFFER-TO-SAVE POP-DOC-STATE ?DE-ALLOCATE
   FULL-SLAT @>SLAT  TRUE TO SWITCH-STATE
;

: REST ( -- )
   SAVE-PLACE OFFER-TO-SAVE
   TEXT-SLAT @>SLAT CLEAR-SLAT
   TRUE TO SWITCH-STATE
   Doc-State @ TO PRESERVE-STATE
   Doc-State OFF Old-Doc-State OFF
;    

: ADD-FILE ( -- )
   S" Filename? " REQUEST-STRING IF
      ?DE-ALLOCATE
      PAD COUNT PUSH-DOC-STATE
      TRUE TO SWITCH-STATE
   THEN
;

\ *****
: ADD-MARKED ( -- )
   MARKED-STRING  PUSH-DOC-STATE TRUE TO SWITCH-STATE
;

: NEXT-FILE ( -- )
   Doc-State @ next? IF
      Doc-State @ last-link>first Doc-State !
      ?DE-ALLOCATE TRUE TO SWITCH-STATE
   THEN    
;

: PRIOR-FILE ( -- )
   Doc-State @ next? IF
      Doc-State @ first-link>last Doc-State !
      ?DE-ALLOCATE TRUE TO SWITCH-STATE
   THEN
;


\ *** help - designed for 8 line pop-up **

: HELP-LINE-Y ( plank -- )
   SLAT-Y [CHAR] [ EMIT ." HELP" [CHAR] ] EMIT 2 SPACES
;


: HELP0 ( -- )
   TEXT1-SLAT NEW-SLAT
   0 HELP-LINE-Y ^COMMAND EMIT 2 SPACES
      ." is the command mode prefix"
   1 HELP-LINE-Y ^COMMAND DUP EMIT EMIT SPACE
      ." is the command prefix character itself"
   2 HELP-LINE-Y ." [space] to drop into text mode"
   3 HELP-LINE-Y  ^left EMIT SPACE
                  ^right EMIT SPACE
                  ^up EMIT SPACE
                  ^down EMIT SPACE
                  ."   Move...        left/right   up/down"
   4 HELP-LINE-Y  ^FirstCol EMIT SPACE
                  ^LastCol EMIT SPACE
                  ^TOF EMIT SPACE
                  ^EOF EMIT SPACE
                  ."   All the way... left/right   up/down" 

   5 HELP-LINE-Y  ^PriorWord EMIT SPACE
                  ^NextWord EMIT SPACE
                  ^PageUp EMIT SPACE
                  ^PageDown EMIT SPACE
                  ."   Hop...         back/forward up/down"            
   6 HELP-LINE-Y  ^Save EMIT 2 SPACES
                   ^Help EMIT 2 SPACES
                  ^good-bye EMIT
                  ."  Save text     Help screens      Exit BMW"

   7 SLAT-Y .tabs
;

: HELP1 ( -- )
   TEXT1-SLAT NEW-SLAT
   0 HELP-LINE-Y  ^Find-string   EMIT SPACE
                  ^find-aGain    EMIT SPACE
                  ^Replace       EMIT SPACE
                  ^replace-Too   EMIT SPACE
   SPACE          ." Find/Again     Replace/HereToo"

   1 HELP-LINE-Y  ^un/mark       EMIT 7 SPACES
   SPACE          ." ToggleMark"

   2 HELP-LINE-Y  ^Copy          EMIT 3 SPACES
                  ^Delete        EMIT 3 SPACES
   SPACE          ." Copy Block     Delete Block/Character"

   3 HELP-LINE-Y  ^Embed         EMIT 3 SPACES
                  ^Wedge         EMIT 3 SPACES
   SPACE          ." Embed Block    Wedge Input Line"

   4 HELP-LINE-Y  ^cut-line      EMIT 3 SPACES
                  ^pin-line      EMIT 3 SPACES
   SPACE          ." Cut Line Out   Paste Line In"

   5 HELP-LINE-Y  ^change-name   EMIT 2 SPACES
                  ^Alter-input   EMIT 2 SPACES
                  ^Show          EMIT SPACE
   SPACE          ." Rename     Insert?   Show WhiteSpace?"

   6 HELP-LINE-Y  -Enter-key        EMIT 2 SPACES
                  -Tab-key          EMIT 2 SPACES
                  -Backspace-key(1) EMIT 2 SPACES
                  ." Return      Tab      Backspace"

   7 SLAT-Y .tabs
;         

: HELP2 ( -- )
   TEXT1-SLAT NEW-SLAT
   0 HELP-LINE-Y  ^StoreTo       EMIT SPACE
                  ^StoreClip     EMIT SPACE
                  ^FetchFrom     EMIT SPACE
                  ^FetchClip     EMIT SPACE
   SPACE          ." Store File/Clip         Fetch File/Clip"

   1 HELP-LINE-Y  ^GetTarget     EMIT SPACE
                  ^ToTarget      EMIT SPACE
                  ^StrFirst      EMIT SPACE
                  ^StrSeek       EMIT SPACE
   SPACE          ." Go/Return to line#   First/Next string"

   2 HELP-LINE-Y  ^WriteChar     EMIT SPACE
                  ^InsertChar    EMIT SPACE
                  ^MarkPlace     EMIT SPACE
                  ^SeekPlace     EMIT SPACE
   SPACE          ." Plot/Insert Char     Insert/Goto Marker"

   3 HELP-LINE-Y  ^MiniMarker    EMIT SPACE
                  ^DecrMarker    EMIT SPACE
                  ^MaxiMarker    EMIT SPACE
                  ^IncrMarker    EMIT SPACE
   SPACE          ." Min/Decrease Marker     Max/Increase Marker "

   4 HELP-LINE-Y
   5 HELP-LINE-Y  ." \o bmw-toc.txt [cr] for more help"
   6 HELP-LINE-Y  ." \h once more to close this pop-up display"

   7 SLAT-Y .tabs
;         

\ show help
: HELP ( -- )
   HELP-SHOWING? IF
      HELP-SCREEN DUP INCR @ CASE
         1 OF HELP1 ENDOF
         2 OF HELP2 ENDOF
         FALSE TO HELP-SHOWING? .BANNER
         TEXT0-SLAT SLAT@ TEXT-SLAT SLAT!
      ENDCASE
   ELSE
      HELP-SCREEN OFF
      char-now @ PLANKS HELP-PLANKS - AIM
      TRUE TO HELP-SHOWING? .BANNER
      TEXT2-SLAT SLAT@ TEXT-SLAT SLAT!      
      HELP0
   THEN
   TEXT-SLAT @>SLAT
   top-line @ .start !
   last-line @ DUP .end ! .mend !
;

\ *** Every which WAY **
\ most commands depend on whether you're inserting,
\ overwriting, or marking text
\                    Insert      Overwrite   Marking
3 WAYS <.WAY>        .INSERT     .OVERWRITE  .MARKING
3 WAYS CHARACTER     INSERT      OVERWRITE   DEEP
3 WAYS ENTER         PARAGRAPH   RETURN      RETURN
3 WAYS BACKSPACE     <DELETE     <DELETE     ?BEEP
3 WAYS TABITHA       NUDGE       HOP         ?BEEP
3 WAYS FIND-1ST      SEEK?       SEEK?       SEEK-MARKED
3 WAYS FIND-AGAIN    SEEK        SEEK        ?BEEP
3 WAYS REPLACE       PUT?        PUT?        ?BEEP
3 WAYS REPLACE-TOO   PUT         PUT         ?BEEP
3 WAYS ~MARK         +MARK       +MARK       -MARK
3 WAYS SEEK-NEXT     SEEK-WORD   SEEK-WORD   SEEK-MARKED
3 WAYS SEEK-FIRST    FIRST-WORD  FIRST-WORD  FIRST-MARKED
3 WAYS COPY          ?BEEP       ?BEEP       APE
3 WAYS EMBED         PASTE       PASTE       ?BEEP
3 WAYS DELE          DELETE      DELETE      CUT
3 WAYS DELE-LINE     CUT-LINE    CUT-LINE    ?BEEP
3 WAYS UNDELE-LINE   PIN-LINE    PIN-LINE    ?BEEP
3 WAYS WEDGE         STUFF       STUFF       ?BEEP
3 WAYS ~INPUT        ~INSERT     ~INSERT     ?BEEP
3 WAYS ~SHOW         ~DISPLAY    ~DISPLAY    ~DISPLAY
3 WAYS SAVING        SAVE-DOC    SAVE-DOC    SAVE-MARKED-AS
3 WAYS FILE-FETCH    FROM>       FROM>       ?BEEP
3 WAYS CLIP-FETCH    FROM-CLIP   FROM-CLIP   ?BEEP
3 WAYS STORE-TO      SNIP-AS     SNIP-AS     CLIP-MARKED-AS
3 WAYS STORE-CLIP    SNIP        SNIP        CLIP-MARKED
3 WAYS DO-FORTH      DO-INPUT    DO-INPUT    DO-MARKED

3 WAYS ADD-DOC       ADD-FILE ADD-FILE ADD-MARKED

\ there had to be a (.WAY
' <.WAY> TO (.WAY

\ *** control keys and commanding **
: INSERT-KEY ( -- ) in-key DROP INSERT ;

: WRITE-KEY ( -- ) in-key DROP OVERWRITE ;

\ toggle text-entry and command modes
: +COMMANDING ( -- )
   TRUE TO Commanding?
   Command-Tab TO Current-Tab
   .BANNER
;

: -COMMANDING ( -- )
   FALSE TO Commanding?
   Text-Tab TO Current-Tab
   MARKING? IF -MARK THEN
   .BANNER
;

\ control-key handler
: CONTROL-KEY? ( u -- )
   CASE
     'CR  OF  PARAGRAPH  ENDOF
      BS  OF  <DELETE    ENDOF
      DEL OF  <DELETE    ENDOF
      HT  OF  NUDGE      ENDOF
              ?BEEP
   ENDCASE
;


\ The flag is set true if an escape was performed
\  An escape command is performed if c1 is the escape, unless
\  the following character is a repeat
\  NB. By default, command-char? eats non-keyboard events

0 VALUE ESCAPE?

: .ESCAPE-NOTICE ( -- )
   ." Repeat " ^COMMAND EMIT
   ."  for literal, otherwise begin commands."
;

: ESCAPE-SWITCH ( -- )
   TRUE TO ESCAPE?
   Transition-Tab TO Current-TAB
\ *****
   ['] .ESCAPE-NOTICE TO (.REACTION
   .BANNER
;

\ command-mode key handler
: COMMAND-MODE ( c1 -- c2 )
   >upper
   CASE

      ^OpenFile         OF ADD-DOC        ENDOF

      ^PriorFile        OF PRIOR-FILE     ENDOF
      ^NextFile         OF NEXT-FILE      ENDOF


      ^Interpreter      OF REST           ENDOF
      ^Interpret        OF DO-FORTH       ENDOF

     \ cursor keys
      ^left             OF LEFT           ENDOF
      ^right            OF RIGHT          ENDOF
      ^PriorWord        OF WORD-LEFT      ENDOF
      ^NextWord         OF WORD-RIGHT     ENDOF
      ^up               OF UP             ENDOF
      ^down             OF DOWN           ENDOF
      ^FirstCol         OF HOME-LEFT      ENDOF
      ^LastCol          OF HOME-RIGHT     ENDOF
      ^PageUp           OF JUMP-UP        ENDOF
      ^PageDown         OF JUMP-DOWN      ENDOF
      ^TOF              OF >TOF           ENDOF
      ^EOF              OF >EOF           ENDOF

     \ function keys
      ^Find-string      OF FIND-1ST       ENDOF
      ^find-aGain       OF FIND-AGAIN     ENDOF
      ^Replace          OF REPLACE        ENDOF
      ^replace-Too      OF REPLACE-TOO    ENDOF
      ^SeekPlace        OF SEEK-PLACE     ENDOF
      ^MarkPlace        OF MARK-PLACE     ENDOF
      ^DecrMarker       OF DECR-MARKER    ENDOF
      ^IncrMarker       OF INCR-MARKER    ENDOF
      ^MiniMarker       OF MIN-TO-MARKER  ENDOF
      ^MaxiMarker       OF MAX-TO-MARKER  ENDOF
      ^GetTarget        OF GET-TARGET     ENDOF
      ^ToTarget         OF >TARGET        ENDOF

      ^un/mark          OF ~MARK          ENDOF
      ^StrSeek          OF SEEK-NEXT      ENDOF
      ^StrFirst         OF SEEK-FIRST     ENDOF

      ^Margin           OF GET-MARGIN     ENDOF

      ^Delete           OF DELE           ENDOF
      ^cut-line         OF DELE-LINE      ENDOF
      ^pin-line         OF UNDELE-LINE    ENDOF
      ^Wedge            OF WEDGE          ENDOF
      ^FetchFrom        OF FILE-FETCH     ENDOF
      ^FetchClip        OF CLIP-FETCH     ENDOF
      ^StoreTo          OF STORE-TO       ENDOF
      ^StoreClip        OF STORE-CLIP     ENDOF

      ^Copy             OF COPY           ENDOF
      ^Embed            OF EMBED          ENDOF
      ^InsertChar       OF INSERT-KEY     ENDOF
      ^WriteChar        OF WRITE-KEY      ENDOF

      ^COMMAND          OF ESCAPE-SWITCH  ENDOF

      ^Help             OF HELP           ENDOF

      ^Alter-input      OF ~INPUT         ENDOF
      ^Show             OF ~SHOW          ENDOF
      ^change-name      OF ~NAME          ENDOF

      ^Save             OF SAVING         ENDOF
      ^good-Bye         OF FINISH         ENDOF

       \ -control-keys

      -Enter-key        OF ENTER          ENDOF
      -Backspace-key(1) OF BACKSPACE      ENDOF
      -Backspace-key(2) OF BACKSPACE      ENDOF
      -Tab-key          OF TABITHA        ENDOF

      BL                OF -COMMANDING    ENDOF

      DUP CONTROL-KEY?

   ENDCASE
;

\ Uniformly (in either mode)
\ ^COMMAND for command mode, except
\     ^COMMAND twice for the character itself
: KEY-OUT ( c -- )
   DUP BL LAST-DISPLAYABLE
   BETWEEN IF CHARACTER ELSE CONTROL-KEY? THEN
;

: ESCAPE-EVENT ( c -- )
   DUP ^COMMAND = IF
      KEY-OUT -COMMANDING
   ELSE
      +COMMANDING COMMAND-MODE
   THEN
;

\ *** the primary editing process
\ get ready to process a keyboard event
: PROCESS> ( -- )
   line-now @  DUP line-old !
   top-line @  DUP top-old !
   last-line @  DUP last-old !  CLAMP
   DUP .start !  1-  DUP .end !  .mend !
;

\ process a character

\ process keyboard events (such as a cursor key)
\ if using ekey

: OTHER-KEYBOARD-EVENT ( u -- )  DEEP ;

: TEXT-MODE ( c -- )
   DUP ^COMMAND = IF DROP ESCAPE-SWITCH ELSE KEY-OUT THEN
;

: CHAR-EVENT ( c -- )
   ESCAPE? IF
      FALSE TO ESCAPE? ESCAPE-EVENT
   ELSE
      Commanding? IF COMMAND-MODE ELSE TEXT-MODE THEN
   THEN
;

\ * handle a keyboard event
: PROCESS-KEY ( c flag -- )
   PROCESS> IF CHAR-EVENT ELSE OTHER-KEYBOARD-EVENT THEN
;

\ This is a common core, with a filestate (name & cursor) already
\ stored, ready to be loaded into memory
\ *****
: EDITing ( c-addr u -- )
   BEGIN Doc-State @ WHILE
      START
      BEGIN
         ?BLOCK .RESULT
         in-key PROCESS-KEY
       SWITCH-STATE UNTIL
   REPEAT .DONE
;

\  With a slight modification, this CATCH/THROW would be the
\ that E. Rather describes as slightly less dumb than the
\ dumbest possible use of CATCH.  However, note that this is
\ dumber than her version, since it will often be throwing an
\ ior, which crashes some implementations,
\  In my opinion, that would equal two bad programs:
\ this one, which threw a code without handling it,
\ and the implementation, for returning an ior that crashes
\ it when thrown.

: FILE-WRITER ( -- )
   ['] EDITing CATCH
   ?DUP IF 0 CLEAR-PLANK DUP . ."  Thrown " THROW THEN
;

ONLY FORTH ACT DEFINITIONS TOOLS BMW TOOLS BMWTOOLS

\ Bruce McFarling's WRITE, yet another NPBP ANS Forth text editor
: WRITER ( c-addr u -- )
   DUP NOT IF
      ." No file name given, using " NO-NAME$ TYPE
      CR wait 2DROP NO-NAME$
   THEN PUSH-DOC-STATE
   DISPLAY-TOP SET-DISPLAY-TOP
   DISPLAY-LINES SET-SUBSLATS {c}
   FILE-WRITER
;

: WRITER" ( -- ) [CHAR] " PARSE WRITER ;

: REWRITE ( -- )
   PRESERVE-STATE ?DUP IF
      Doc-State !
      FALSE TO RESTING
      FULL-DISPLAY FILE-WRITER
   ELSE
      CR ." Use WRITER" .QUOTE ."  <filename>" .QUOTE
      CR ."  because the filename is not available in memory."
   THEN
;

CR
CR .( S" <filename>" WRITER to begin the editor )
CR .( or WRITER" <filename>" )
CR
