\ ** program parameters: adjust constants as needed **

\ characters for displaying "invisibles"
CHAR _ CONSTANT .BL     \ BL
CHAR | CONSTANT .CR     \ CR
CHAR ^ CONSTANT .OTHER  \ other character < ASCII 32

\ * keyboard entry
\ ASCII characters used in command mode -- command mode 
\ provides all the functions that BMW implements

\ two of these start, one ends command mode
\ consider using ESCape once if it's available
CHAR \ CONSTANT ^COMMAND

\ One of these escapes from text mode to command mode
\ for a single command.  A NOP in command mode
\ Two consecutive is the ^ESCAPE character itself
\ A macro key program may use ^ESCAPE <command-char> to
\ define commands without tracking Command/text mode changes
CHAR ` CONSTANT ^ESCAPE

\ command keys
CHAR F CONSTANT ^Find-string
CHAR G CONSTANT ^find-aGain
CHAR R CONSTANT ^Replace
CHAR T CONSTANT ^replace-Too

CHAR " CONSTANT ^QuoteBlock
CHAR ' CONSTANT ^un/mark

CHAR C CONSTANT ^Copy
CHAR D CONSTANT ^Delete
CHAR Y CONSTANT ^cut-line
CHAR N CONSTANT ^pin-line
CHAR E CONSTANT ^Embed
CHAR W CONSTANT ^Wedge

CHAR H CONSTANT ^Help
CHAR A CONSTANT ^Alter-input
CHAR Z CONSTANT ^Show

CHAR X CONSTANT ^change-name

CHAR S CONSTANT ^Save

\ Not yet implemented
CHAR 8 CONSTANT ^InterpretLine

CHAR | CONSTANT ^Command2

CHAR { CONSTANT ^PriorFile
CHAR } CONSTANT ^NextFile
CHAR [ CONSTANT ^PriorBlock
CHAR ] CONSTANT ^NextBlock

CHAR U CONSTANT ^User

CHAR M CONSTANT ^Margin

CHAR O CONSTANT ^OpenFile
CHAR Q CONSTANT ^QuitFile

CHAR P CONSTANT ^Print
CHAR V CONSTANT ^View


\ * shiftable functions
CHAR ` CONSTANT ^Interpret
CHAR ~ CONSTANT ^Interpreter
CHAR 1 CONSTANT ^StoreClip
CHAR ! CONSTANT ^StoreTo
CHAR 2 CONSTANT ^FetchClip
CHAR @ CONSTANT ^FetchFrom
CHAR 3 CONSTANT ^ToTarget
CHAR # CONSTANT ^GetTarget
CHAR 4 CONSTANT ^StrSeek
CHAR $ CONSTANT ^StrFirst
CHAR 5 CONSTANT ^User1
CHAR % CONSTANT ^User2
CHAR 6 CONSTANT ^InsertChar
CHAR ^ CONSTANT ^WriteChar
CHAR 7 CONSTANT ^User3
CHAR & CONSTANT ^User4
CHAR 8 CONSTANT ^SeekPlace
CHAR * CONSTANT ^MarkPlace
CHAR 9 CONSTANT ^DecrMarker
CHAR ( CONSTANT ^MiniMarker
CHAR 0 CONSTANT ^IncrMarker
CHAR ) CONSTANT ^MaxiMarker

CHAR B CONSTANT ^good-Bye

\ next 6 aren't shown in the help screen
\ I don't expect them to be used but they would
\ eliminate the environmental dependency on the use of
\ control codes (if you silence BEEP)
CHAR _ CONSTANT -Backspace-key(1)
CHAR - CONSTANT -Backspace-key(2)
CHAR + CONSTANT -Tab-key
CHAR = CONSTANT -Enter-key

\ cursor keys
CHAR L CONSTANT ^right
CHAR J CONSTANT ^left
CHAR I CONSTANT ^up
CHAR K CONSTANT ^down
CHAR < CONSTANT ^FirstCol
CHAR , CONSTANT ^PriorWord
CHAR > CONSTANT ^LastCol
CHAR . CONSTANT ^NextWord
CHAR : CONSTANT ^TOF
CHAR ; CONSTANT ^PageUp
CHAR ? CONSTANT ^EOF
CHAR / CONSTANT ^PageDown

\ ASCII control characters
\ use of control characters is an environmental dependency
 7 CONSTANT BEL    \ bell
 8 CONSTANT BS     \ backspace
 9 CONSTANT HT     \ horizontal tab
\ 10 CONSTANT LF   \ BMW doesn't know LF
12 CONSTANT FF   \ formfeed for printing
13 CONSTANT 'CR    \ Enter (also marks end of a paragraph)
127 CONSTANT DEL  \ some systems bind their backspace to DEL
