\ bmwtools.fs version 0.0.8 23 January 1998
\ Copyright Leo Wong, 1997, except indicated
\ material copyright Bruce McFarling, 1997-1999.
\ See bmw.fs for conditions.

\ BMWTOOLS.F has been updated to use the TOOLS / ACT system

GET-ORDER
ONLY FORTH TOOLS DEFINITIONS
MARKER *BMWTOOLS* VOCABULARY BMWTOOLS
ALSO BMWTOOLS DEFINITIONS

\ ** tools **
\ some of these may already exist in your ANS Forth
\ if so, then feel free to comment them out, but please retain
\ a copy of the original for redistribution

\ do nothing
: NOP ( -- ) ;

\ number of address units in a cell/character
1 CELLS CONSTANT /CELL
1 CHARS CONSTANT /CHAR

\ stack manipulation
: -ROT  ( x1 x2 x3 -- x3 x1 x2 )  ROT ROT ;

\ unsigned max and min
: UMAX  ( u1 u2 -- u1|u2 )  2DUP U< IF  NIP  ELSE  DROP  THEN ;
: UMIN  ( u1 u2 -- u1|u2 )  2DUP U< IF  DROP  ELSE  NIP  THEN ;

\ BMW belongs to the logical NOT as 0= camp
: NOT ( flag -- ~flag ) 0= ;

\ increment/decrement variable
: INCR  ( a -- )  1 SWAP +! ;
: DECR  ( a -- )  -1 SWAP +! ;

\ add stack items
: UNDER+  ( n1 n2 n3 -- n1+n3 n2 )  ROT + SWAP ;

\ unsigned division
: U/MOD  ( u1 u2 -- r q )  >R  1 UM*  R> UM/MOD ;
: U/  ( u1 u2 -- u1/u2 )  U/MOD  NIP ;

\ fences
: BETWEEN  ( n1 n2 n3 -- f)  1+ WITHIN ;
: CLAMP  ( n1 lo hi - n2)  ROT MIN MAX ;

\ The tools / pet words that follow are
\ by Bruce McFarling, thought the marked
\ drop off in quality should suffice to
\ indicate that.

\ fetch/store with auto-increment
\ in various combinations, these give filtered inter-buffer
\ transfers, FILO buffers, and FIFO buffers
\ cf. COMUS: @GET is @+ or `CELL-COUNT'
\ but !PUT is not !+ which has a stack effect of ( a x -- a++ )
: @GET ( a -- a++ x ) DUP CELL+ SWAP @ ;
: !PUT ( x a -- a++ ) DUP >R ! R> CELL+ ;
: @POP ( a -- x --a ) /CELL - DUP @ ;

: DUP-3RD ( u1 u2 u3 -- u1 u2 u3 u1 )  2 PICK ;
: 2DUP-3RD ( u1 u2 u3 -- u1 u2 u3 u1 u2 ) OVER >R DUP-3RD R> ;


\ minor space saver
: .QUOTE ( -- ) [CHAR] " EMIT ;

1 CONSTANT BARELY
TRUE BARELY XOR CONSTANT MOSTLY

: EXACT? ( u -- flag ) TRUE = ;
: TRUE? ( u -- flag ) 0= 0= ;
: FALSE? ( u -- flag ) 0= ;

SET-ORDER

CR .( BMWTOOLS available in current TOOLS vocabulary )
